package risc;

public abstract class StringHelper {

    public static String toIntString(int value) {
        return Integer.toString(value);
    }

    public static String toIntString(int value, int width) {
        return pad(width, ' ', toIntString(value));
    }

    public static String toBinString(int value) {
        return Integer.toBinaryString(value);
    }

    public static String toBinString(int value, int width) {
        return pad(width, '0', toBinString(value));
    }

    public static String toDecString(int value) {
        return Long.toString((long)value & 0x00000000FFFFFFFFl);
    }

    public static String toDecString(int value, int width) {
        return pad(width, '0', toDecString(value));
    }

    public static String toHexString(int value) {
        return Integer.toHexString(value).toUpperCase();
    }

    public static String toHexString(int value, int width) {
        return pad(width, '0', toHexString(value));
    }

    public static String pad(int width, String string, char pad) {
        return string + pad(width - string.length(), pad);
    }

    public static String pad(int width, char pad, String string) {
        return pad(width - string.length(), pad) + string;
    }

    public static String pad(int width, char pad) {
        if (width <= 0) return "";
        StringBuffer buffer = new StringBuffer(width);
        for (int i = 0; i < width; i++) buffer.append(pad);
        return buffer.toString();
    }

}
