package risc.debugger;

/**
 * A new function Type
 *
 * 05.05.01
 *
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Function {

    private int       address;
    private String    name;
    private int[]     r;
    private int       callerAddress;

    public Function() {}
    public Function(int address) {
	this.address = address;
    }
    public Function(String name) {
	this.name = name;
    }
    public Function(int[] r) {
	this.r = new int[r.length];
	for (int i=0; i<r.length; i++) 
	    this.r[i] = r[i];
    }
    public Function(int address, String name) {
	this.address = address;
	this.name = name;
    }
    public Function(int address, int[] r) {
	this.address = address;
	this.r = new int[r.length];
	for (int i=0; i<r.length; i++) 
	    this.r[i] = r[i];
    }
    public Function(String name, int[] r) {
	this.name = name;
	this.r = new int[r.length];
	for (int i=0; i<r.length; i++) 
	    this.r[i] = r[i];
    }
    public Function(int address, String name, int[] r, int callerAddress) {
	this.address = address;
	this.name = name;
	this.r = new int[r.length];
// 	System.out.println();
// 	System.out.println("Function:" + name);
	for (int i=0; i<r.length; i++) {
	    this.r[i] = r[i];
// 	    System.out.println("r["+i+"] = " + r[i]);
	}
	this.callerAddress = callerAddress;
    }
	
    public void setAddress(int address) {
	this.address = address;
    }
    public void setName(String name) {
	this.name = name;
    }
    public void setR(int[] r) {
	this.r = new int[r.length];
	for (int i=0; i<r.length; i++) 
	    this.r[i] = r[i];
    }
    public void setRAt(int value, int index) throws ArrayIndexOutOfBoundsException {
	r[index] = value;
    }
    public int getAddress() {
	return address;
    }
    public String getName() {
	return name;
    }
    public int getRAt(int index) throws ArrayIndexOutOfBoundsException {
	return r[index];
    }

    public int getCallerAddress() {
	return callerAddress;
    }

} // class Function

