package risc.syscall;

import risc.RISC;
import risc.emulator.Emulator;

public class Miscellaneous extends AbstractHandler implements Dispatchee {

    //########################################################################
    // Dispatchee interface

    public int[] getHandledSysCalls() {
        return new int[] {
            RISC.SYS_GET_TOTAL_MEM_SIZE,
            RISC.SYS_EXIT,
        };
    }

    //########################################################################
    // SysCallHandler interface

    public int handle(int sc, int a, int b, Emulator emu)throws Emulator.Exception{
        switch (sc) {

        case RISC.SYS_GET_TOTAL_MEM_SIZE:
            return emu.getMemorySize();

        case RISC.SYS_EXIT:
            throw new Emulator.Exit(a);

        default:
            return super.handle(sc, a, b, emu);
        }
    }

    //########################################################################
}
